Package com.avaya.clientservices.call.feature

## Class FeatureStatusParameters

- java.lang.Object
- - com.avaya.clientservices.call.feature.FeatureStatusParameters

-     public class FeatureStatusParameters
      extends java.lang.Object

  The parameters that can be present in the status for any supported feature.

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `FeatureStatusParameters​(int buttonLocation, FeatureType feature, FeatureStatus status)` | Constructs the FeatureStatusParameters object from specified parameters.
    `FeatureStatusParameters​(int buttonLocation, FeatureType feature, FeatureStatus status, java.lang.String ownerExtension, java.lang.String destination, java.lang.String destinationShortForm, java.lang.String featureLabel, boolean isDestinationExtensionEditable, EnhancedCallForwardingStatus enhancedCallForwardingStatus, int groupNumber, boolean isFeatureLabelEditable)` | Constructs the FeatureStatusParameters object from specified parameters.
    `FeatureStatusParameters​(int buttonLocation, FeatureType feature, FeatureStatus status, java.lang.String ownerExtension, java.lang.String destination, java.lang.String destinationShortForm, java.lang.String featureLabel, boolean isDestinationExtensionEditable, EnhancedCallForwardingStatus enhancedCallForwardingStatus, SimRingCallbackStatusParameters simRingCallbackStatusParameters, int groupNumber, java.lang.String dialCode, boolean isFeatureLabelEditable, Call call, FeatureMode featureMode)` | Constructs the FeatureStatusParameters object from specified parameters.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `boolean` | `equals​(java.lang.Object obj)` |
    `int` | `getButtonLocation()` |
    `Call` | `getCall()` |
    `java.lang.String` | `getDestination()` | Returns the destination extension associated with this feature.
    `java.lang.String` | `getDestinationLabel()` | Deprecated. THIS METHOD WILL BE REMOVED.
    `java.lang.String` | `getDestinationShortForm()` | This field will be populated only when received from the server.
    `java.lang.String` | `getDialCode()` |
    `EnhancedCallForwardingStatus` | `getEnhancedCallForwardingStatus()` |
    `FeatureType` | `getFeature()` |
    `java.lang.String` | `getFeatureLabel()` | This is the label of the feature button.
    `int` | `getGroupNumber()` |
    `int` | `getHuntGroupNumber()` | Deprecated. THIS METHOD WILL BE REMOVED.
    `FeatureMode` | `getMode()` |
    `java.lang.String` | `getOwnerExtension()` | Returns the owner extension associated with this feature.
    `SimRingCallbackStatusParameters` | `getSimRingCallbackStatusParameters()` |
    `FeatureStatus` | `getStatus()` |
    `int` | `hashCode()` |
    `boolean` | `isDestinationExtensionEditable()` | Indicates whether the Autodial destination extension can be edited or not by the user.
    `boolean` | `isFeatureLabelEditable()` | Indicates whether the feature label can be edited or not by the user.
    `java.lang.String` | `toString()` |

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### FeatureStatusParameters

          public FeatureStatusParameters​(int buttonLocation,
                                         FeatureType feature,
                                         FeatureStatus status)

      Constructs the FeatureStatusParameters object from specified parameters.
      Parameters:
        `buttonLocation` - Index of button.
        `feature` - Feature type.
        `status` - Feature status.
      See Also:
        `FeatureType`, `FeatureStatus`

    - #### FeatureStatusParameters

          public FeatureStatusParameters​(int buttonLocation,
                                         FeatureType feature,
                                         FeatureStatus status,
                                         java.lang.String ownerExtension,
                                         java.lang.String destination,
                                         java.lang.String destinationShortForm,
                                         java.lang.String featureLabel,
                                         boolean isDestinationExtensionEditable,
                                         EnhancedCallForwardingStatus enhancedCallForwardingStatus,
                                         int groupNumber,
                                         boolean isFeatureLabelEditable)

      Constructs the FeatureStatusParameters object from specified parameters.
      Parameters:
        `buttonLocation` - Index of button.
        `feature` - Feature type.
        `status` - Feature status.
        `ownerExtension` - Owner user extension.
        `destination` - Destination extension.
        `destinationShortForm` - Shortform text of destination if configured at CM.
        `featureLabel` - Label text of destination if configured at CM.
        `isDestinationExtensionEditable` - True if detination extension is editable by user.
        `enhancedCallForwardingStatus` - Enhanced call forwarding feature status.
        `groupNumber` - Hunt/Intercom Group Number populated with value of "avaya-cm-group" parameter if present in feature status notify.
        `isFeatureLabelEditable` - True if feature label is editable by the user.

    - #### FeatureStatusParameters

          public FeatureStatusParameters​(int buttonLocation,
                                         FeatureType feature,
                                         FeatureStatus status,
                                         java.lang.String ownerExtension,
                                         java.lang.String destination,
                                         java.lang.String destinationShortForm,
                                         java.lang.String featureLabel,
                                         boolean isDestinationExtensionEditable,
                                         EnhancedCallForwardingStatus enhancedCallForwardingStatus,
                                         SimRingCallbackStatusParameters simRingCallbackStatusParameters,
                                         int groupNumber,
                                         java.lang.String dialCode,
                                         boolean isFeatureLabelEditable,
                                         Call call,
                                         FeatureMode featureMode)

      Constructs the FeatureStatusParameters object from specified parameters.
      Parameters:
        `buttonLocation` - Index of button.
        `feature` - Feature type.
        `status` - Feature status.
        `ownerExtension` - Owner user extension.
        `destination` - Destination extension.
        `destinationShortForm` - Shortform text of destination if configured at CM.
        `featureLabel` - Label text of destination if configured at CM.
        `isDestinationExtensionEditable` - True if detination extension is editable by user.
        `enhancedCallForwardingStatus` - Enhanced call forwarding feature status.
        `simRingCallbackStatusParameters` - Callback / simultaneous ring feature parameters.
        `groupNumber` - Hunt/Intercom Group Number populated with value of "avaya-cm-group" parameter if present in feature status notify.
        `dialCode` - Dial code populated with value of "avaya-cm-dial-code" parameter if present in feature status notify.
        `isFeatureLabelEditable` - True if feature label is editable by the user.
        `call` - Call instance assiciated with the feature.
        `featureMode` - Feature mode.

  - ### Method Detail

    - #### getButtonLocation

          public int getButtonLocation()

      Returns:
        the feature button location.

    - #### getFeature

          public FeatureType getFeature()

      Returns:
        the feature type.

    - #### getStatus

          public FeatureStatus getStatus()

      Returns:
        the feature status.

    - #### getOwnerExtension

          public java.lang.String getOwnerExtension()

      Returns the owner extension associated with this feature. When this parameter is empty, the feature is associated with the local user.
      Returns:
        the owner extension associated with this feature.

    - #### getDestination

          public java.lang.String getDestination()

      Returns the destination extension associated with this feature. Populated with the value of the 'avaya-cm-destination' parameter if present in the status update.
      Returns:
        the destination extension associated with this feature.

    - #### getDestinationShortForm

          public java.lang.String getDestinationShortForm()

      This field will be populated only when received from the server. This is the short form of the URI. It can be received in feature status update. E.g.: <feature-status entity="sip:14088640028@svuca.com" version="1" state="full" avext="40028"> <feature name ="busy-indicator" status="off"/> </feature-status>
      Returns:
        destination short form.

    - #### getDestinationLabel

          @Deprecated
          public java.lang.String getDestinationLabel()

      Deprecated.
      THIS METHOD WILL BE REMOVED. Use getFeatureLabel() instead.
      This is the location of the feature button as configured on server. This is normally associated with Autodial feature buttons
      Returns:
        the destination label of the feature.

    - #### getFeatureLabel

          public java.lang.String getFeatureLabel()

      This is the label of the feature button.
      Returns:
        the label of the feature button.

    - #### isDestinationExtensionEditable

          public boolean isDestinationExtensionEditable()

      Indicates whether the Autodial destination extension can be edited or not by the user.
      Returns:
        true if destination extension can be edited by the user.

    - #### getEnhancedCallForwardingStatus

          public EnhancedCallForwardingStatus getEnhancedCallForwardingStatus()

      Returns:
        the Enhanced Call Forwarding feature Status.

    - #### getSimRingCallbackStatusParameters

          public SimRingCallbackStatusParameters getSimRingCallbackStatusParameters()

      Returns:
        the callback / simultaneous ring feature parameters.

    - #### getHuntGroupNumber

          @Deprecated
          public int getHuntGroupNumber()

      Deprecated.
      THIS METHOD WILL BE REMOVED. Use `getGroupNumber()` instead.
      Returns:
        the hunt group number associated with hunt-group-busy-position feature. For other features, this method will return 0.

    - #### getGroupNumber

          public int getGroupNumber()

      Returns:
        the group number associated with hunt-group-busy-position or intercom feature. For other features, this method will return 0.

    - #### getDialCode

          public java.lang.String getDialCode()

      Returns:
        the dial code associated with auto intercom feature.

    - #### getCall

          public Call getCall()

      Returns:
        the call instance associated with auto intercom feature.

    - #### isFeatureLabelEditable

          public boolean isFeatureLabelEditable()

      Indicates whether the feature label can be edited or not by the user.
      Returns:
        true if the feature label can be edited by the user.

    - #### getMode

          public FeatureMode getMode()

      Returns:
        the feature mode.

    - #### toString

          public java.lang.String toString()

      Overrides:
        `toString` in class `java.lang.Object`

    - #### equals

          public boolean equals​(java.lang.Object obj)

      Overrides:
        `equals` in class `java.lang.Object`

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `java.lang.Object`